
<p>Komparator je standardni kombinacijski modul koji na ulaz dobiva dva višebitna binarna uzorka a na izlazima daje informaciju jesu li oni jednaki ili su različiti. Ako binarni uzorci predstavljaju elemente nad kojima je definiran poredak (primjerice, kodirane cijele brojeve), komparator može imati i izlaze na kojima daje informaciju kakav je odnos ta dva broja (manji-jednak; veći-jednak).</p>

<p>U nastavku je prikazana interaktivna simulacija komparatora cijelih brojeva prikazanih 3-bitnim prirodnim binarnim kodom. Broj <i>A</i> određen je bitovima <i>a</i><sub>2</sub><i>a</i><sub>1</sub><i>a</i><sub>0</sub> a broj <i>B</i> bitovima <i>b</i><sub>2</sub><i>b</i><sub>1</sub><i>b</i><sub>0</sub>. Početno je postavljeno <i>A</i>=0, <i>B</i>=0. Bitove obaju kodnih riječi u simulaciji možete mijenjati klikom miša. Postavite nekoliko različitih vrijednosti za <i>A</i> i <i>B</i> i provjerite kako se mijenjaju izlazi komparatora. Na predavanju ćemo naučiti kako se ovakav sklop može izgraditi uporabom osnovnih logičkih sklopova.
</p>

    <canvas id="myCanvas" width="260" height="340" style="margin-left: auto; margin-right: auto; display: block;"></canvas>
    <script>
      var canvas = document.getElementById('myCanvas');
      var context = canvas.getContext('2d');
      var state = {
        currentRow: 0,
        vars: 3,
        outvars: 3,
        elems: [0,0,0,0,0,0],
        outlabels: ["A>B","A=B","A<B"],
        hots: []
      };

      canvas.addEventListener('mousedown', function(evt) {
        var rect = canvas.getBoundingClientRect();
        var pos = {x: evt.clientX - rect.left, y: evt.clientY - rect.top};
        for(var i = 0; i < state.hots.length; i++) {
          var h = state.hots[i];
          if(pos.x>=h.x && pos.x<h.x+h.w && pos.y>=h.y && pos.y<h.y+h.h) {
            state.elems[h.row] = 1-state.elems[h.row];
            draw(canvas, context, state);
            break;
          }
        }
      }, false);

      function draw(canvas, context, state) {
        // clear
        context.clearRect(0, 0, canvas.width, canvas.height);

        // Draw circuit...

        var cloff = 40; var ctoff = 40; var cvertOut = 20; var cvertBetween = 50; var choriz = 150; var connector = 20;
        var plocica = 24;

        var cheightLeft = 2*cvertOut + (2*state.vars-1)*cvertBetween;
        var cheightRight = 2*cvertOut + (state.outvars-1)*cvertBetween;
        var cheight = Math.max(cheightLeft,cheightRight);

        var coffl = (cheight-cheightLeft)/2;
        var coffr = (cheight-cheightRight)/2;

        state.hots.length = 0;
        function handler(x,y,w,h,state,row) {
          this.x = x; this.y = y; this.w = w; this.h = h; this.state = state; this.row = row;
        }

        // Crtaj pločice:
        context.fillStyle = '#aaaaaa';
        for(var v = 0; v < state.vars*2; v++) {
          var x = cloff; var y = ctoff+coffl+cvertOut+v*cvertBetween; 
          context.beginPath();
          context.rect(x-plocica, y-plocica/2, plocica, plocica);
          context.fill();
          state.hots.push(new handler(x-plocica, y-plocica/2, plocica, plocica,state,v));
        }

        context.beginPath();
        context.strokeStyle = '#000000';
        for(var v = 0; v < state.vars*2; v++) {
          context.moveTo(cloff, ctoff+coffl+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector, ctoff+coffl+cvertOut+v*cvertBetween);
        }
        for(var v = 0; v < state.outvars; v++) {
          context.moveTo(cloff + connector + choriz, ctoff+coffr+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector + choriz + connector, ctoff+coffr+cvertOut+v*cvertBetween);
        }
        context.stroke();

        context.beginPath();
        context.fillStyle = '#000000';
        context.rect(cloff + connector, ctoff, choriz, cheight);
        context.fill();

        var cfontSize = 14;
        context.font = 'normal '+cfontSize+'pt Calibri';
        context.textBaseline = 'middle';

        context.beginPath();
        for(var v = 0; v < state.vars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'left';
          context.strokeText("a"+(state.vars-1-v), cloff + connector + 2, ctoff+coffl+cvertOut+v*cvertBetween);
          context.strokeText("b"+(state.vars-1-v), cloff + connector + 2, ctoff+coffl+cvertOut+(v+state.vars)*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'right';
          context.strokeText(''+state.elems[v], cloff - 2, ctoff+coffl+cvertOut+v*cvertBetween);
          context.strokeText(''+state.elems[state.vars+v], cloff - 2, ctoff+coffl+cvertOut+(v+state.vars)*cvertBetween);
        }

        var outputs = determineOutputs(state.elems.slice(0,state.vars),state.elems.slice(state.vars,2*state.vars));
        for(var v = 0; v < state.outvars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'right';
          context.strokeText(state.outlabels[v], cloff + connector + choriz - 2, ctoff+coffr+cvertOut+v*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'left';
          context.strokeText(''+outputs[v], cloff + connector + choriz + connector + 2, ctoff+coffr+cvertOut+v*cvertBetween);
        }
      }

      function determineOutputs(a,b) {
        var x = fromBinary(a);
        var y = fromBinary(b);
        return [x>y?1:0, x==y?1:0, x<y?1:0];
      }

      function fromBinary(b) {
        var n = 0;
        for(var i = 0; i < b.length; i++) {
          n = 2*n + b[i];
        }
        return n;
      }

      draw(canvas, context, state);
    </script>

